'---------------------------------------------------------------------------
'Zentrum fuer Fuzzy- & InformationsTechnik GmbH
'Baumhofweg 4
'D-44267 Dortmund
'
'Copyright (C) by ZeTec
'All rights reserved.

'Dieser Basic-Code wurde automatisch mit der FCU generiert und beinhaltet
'den gesamten Algorithmus zur Berechnung des Fuzzy-Reglers.
'---------------------------------------------------------------------------


DEFINE Summe_Efg    WORD
DEFINE Rest_Summe   WORD
DEFINE Rest_Dummy   WORD
DEFINE Aus_Wert     BYTE
DEFINE Akt_Efg      BYTE
DEFINE Min_Efg      BYTE
DEFINE Reg_Anzahl   BYTE
DEFINE Akt_Regel    BYTE
DEFINE Set_Param    BYTE                         'Erfuellungsgrade = Efgs

DEFINE A            BYTE
DEFINE B            BYTE
DEFINE C            BYTE
DEFINE D            BYTE
DEFINE Eingang      BYTE
DEFINE Akt_Eing     BYTE

DEFINE Eingang_1        AD[5]
DEFINE Eingang_2        AD[6]
DEFINE Ausgang_1        DA[1]

#ANFANG

  LOOKTAB Fuzzy_Sets, 0, Reg_Anzahl
  Reg_Anzahl = Reg_Anzahl-1

  Summe_Efg =  0
  Aus_Wert =   0
  Rest_Summe = 0
  Rest_Dummy = 0

  FOR Akt_Regel = 0 TO Reg_Anzahl

    Akt_Efg = 0
    Min_Efg = 100

    FOR Akt_Eing = 0 TO 2

      IF Akt_Eing = 0 THEN Eingang = Eingang_1

      IF Akt_Eing = 1 THEN Eingang = Eingang_2

      IF Akt_Eing = 2 THEN Eingang = Variable_3?


      Set_Param = 13 * Akt_Regel + Akt_Eing * 4 + 1
      LOOKTAB Fuzzy_Sets, Set_Param, A
      IF A > Eingang THEN GOTO FOR_ENDE_1

      Set_Param = Set_Param + 3
      LOOKTAB Fuzzy_Sets, Set_Param, D
      IF D < Eingang THEN GOTO FOR_ENDE_1

      Set_Param = Set_Param - 2
      LOOKTAB Fuzzy_Sets, Set_Param, B

      Set_Param = Set_Param + 1
      LOOKTAB Fuzzy_Sets, Set_Param, C

      Akt_Efg = 100

      IF Eingang < B THEN GOSUB EFG_LINKS

      IF Eingang > C THEN GOSUB EFG_RECHTS

    NEXT

    Summe_Efg = Summe_Efg + Min_Efg

    #FOR_ENDE_1
  NEXT

  IF Summe_Efg = 0 THEN GOTO ANFANG

  FOR Akt_Regel = 0 TO Reg_Anzahl

    Akt_Efg = 0
    Min_Efg = 100

    FOR Akt_Eing = 0 TO 2

      IF Akt_Eing = 0 THEN Eingang = Eingang_1

      IF Akt_Eing = 1 THEN Eingang = Eingang_2

      IF Akt_Eing = 2 THEN Eingang = Eingang_3


      Set_Param = 13 * Akt_Regel + Akt_Eing * 4 + 1
      LOOKTAB Fuzzy_Sets, Set_Param, A
      IF A > Eingang THEN GOTO FOR_ENDE_2

      Set_Param = Set_Param + 3
      LOOKTAB Fuzzy_Sets, Set_Param, D
      IF D < Eingang THEN GOTO FOR_ENDE_2

      Set_Param = Set_Param - 2
      LOOKTAB Fuzzy_Sets, Set_Param, B

      Set_Param = Set_Param + 1
      LOOKTAB Fuzzy_Sets, Set_Param, C

      Akt_Efg = 100

      IF Eingang < B THEN GOSUB EFG_LINKS

      IF Eingang > C THEN GOSUB EFG_RECHTS

    NEXT

    Set_Param = 13 * Akt_Regel + 13
    LOOKTAB Fuzzy_Sets, Set_Param, A

    Aus_Wert=Aus_Wert+(A*Min_Efg)/Summe_Efg

    Rest_Dummy = Rest_Dummy + (A * Min_Efg) MOD Summe_Efg

    IF Rest_Dummy < 0 THEN GOSUB ZWISCHEN_REST ELSE Rest_Summe = Rest_Dummy
 
   #FOR_ENDE_2
  NEXT

  Aus_Wert = Aus_Wert + Rest_Summe / Summe_Efg

  Ausgang_1 = Aus_Wert                                           '

GOTO ANFANG

END

#EFG_LINKS
  Akt_Efg = (Eingang - A) * 100 / (B- A)
  IF Akt_Efg < Min_Efg THEN Min_Efg = Akt_Efg
RETURN

#EFG_RECHTS
  Akt_Efg = 100 - (Eingang - C) * 100 / (D - C)
  IF Akt_Efg < Min_Efg THEN Min_Efg = Akt_Efg
RETURN

#ZWISCHEN_REST
  Rest_Summe = Rest_Summe / Summe_Efg
  Aus_Wert = Aus_Wert + Rest_Summe
  Rest_Dummy = (A * Min_Efg) MOD Summe_Efg
  Rest_Summe = Rest_Summe MOD Summe_Efg
  Rest_Summe = Rest_Summe + Rest_Dummy
RETURN

TABLE Fuzzy_Sets
8
0   0   80  100 
0   0   255 255 
64  64  234 234 255 
0   0   255 255 
0   0   55  105 
64  64  234 234 255 
80  100 255 255 
0   0   255 255 
64  64  234 234 0   
0   0   255 255 
55  105 255 255 
64  64  234 234 0   
0   0   70  90  
0   0   255 255 
0   0   64  64  255 
0   0   70  90  
0   0   255 255 
234 234 255 255 255 
70  90  255 255 
0   0   255 255 
0   0   64  64  0   
70  90  255 255 
0   0   255 255 
234 234 255 255 0   
